# -*- coding: iso-8859-1 -*-
"""Modulo que implementa downloads no Downtube"""

#
# Downtube - Copyright (c) 2006 Andre Luiz <lidzky@users.sourceforge.net>
#
# $Id: DtDownloader.py,v 1.9.6.3 2006/08/16 04:56:49 lidzky Exp $
#
# Este arquivo  parte do programa Downtube - http://downtube.codigolivre.org.br
#
# O Downtube  um software livre; voc pode redistrubu-lo e/ou modific-lo
# dentro dos termos da Licena Pblica Geral GNU como publicada pela
# Fundao do Software Livre (FSF); na verso 2 da Licena, ou (na sua
# opinio) qualquer verso.
#
# Este programa  distribudo na esperana que possa ser til,
# mas SEM NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a
# qualquer MERCADO ou APLICAO EM PARTICULAR. Veja a
# Licena Pblica Geral GNU para maiores detalhes.
#
# Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob
# o ttulo "LICENCA.txt", junto com este programa; se no, escreva para
# a Fundao do Software Livre(FSF) Inc., 51 Franklin St, Fifth Floor,
# Boston, MA  02110-1301  US
#


# Python modules
from os     import system
from urllib import urlencode

# Downtube modules
from DtData import user_agent, tmpout


class Downloader:

    def __init__(self):
        """class constructor"""

        self.__verbose = True
        self.__wget = 'wget'




    def set_verbose(self, v):
        """sets wget verbosity level"""

        self.__verbose = v
        if self.__verbose:
            wget = 'wget'
        else:
            wget = 'wget -nv'




    def get_video_page(self, url, cookies):
        """downloads video page"""

        cmd = ''.join(['%s' % self.__wget, 
                       ' --referer="%s"'      % url,
                       ' --user-agent="%s"'   % user_agent,
                       ' --load-cookies "%s"' % cookies,
                       ' "%s"'   % url,
                       ' -O "%s"' % tmpout
                       ])

        exit = system(cmd)

        if exit != 0:
            if exit == 2:  # keyboard interrupt
                raise KeyboardInterrupt
            else:
                raise Exception




    def get_video(self, video_url, referer, output, cookies):
        """downloads video file"""

        cmd = ''.join(['%s' % self.__wget, 
                       ' -c --referer="%s"' % referer,
                       ' --user-agent="%s"'     % user_agent,
                       ' --load-cookies "%s"'   % cookies,
                       ' "%s" '   % video_url,
                       ' -O %s' % output
                       ])

        exit = system(cmd)

        if exit != 0:
            if exit == 2:  # keyboard interrupt
                raise KeyboardInterrupt
            else:
                raise Exception
